% 

clear all
close all

PLOT = 1; 
FREQ = 50;

% 1. Initialisation de la structure EDP
EDP.a=0;EDP.b=2*pi;
EDP.t0=0;EDP.T=2;
EDP.nu=2;
EDP.c=@(x) 1+x/4;
k=5;
EDP.uex=@(t,x) cos(k*t)*cos(x);
EDP.f=@(t,x) -k*sin(k*t)*cos(x)+EDP.nu*cos(k*t)*cos(x)+EDP.c(x).*EDP.uex(t,x);
EDP.u0=@(x) EDP.uex(EDP.t0,x);
EDP.ua=@(t) EDP.uex(t,EDP.a);
EDP.ub=@(t) EDP.uex(t,EDP.b);

% 2. Parametres de discretisation
% Decommentez/commentez les differents choix de parametres
% pour mettre en evidence des phenomenes de convergence/divergence

Nx=100;Nt=2100;% => convergence 
%Nx=100;Nt=2000; % => divergence

%Nx=150;Nt=4500; % => divergence
%Nx=150;Nt=4600; % => convergence 

%Nx=200; Nt = 8000; % => divergence
%Nx=200; Nt = 8400; % => convergence

% 3. Verification de la condition de C.F.L.
ht=EDP.T/Nt; hx=(EDP.b-EDP.a)/Nx;
CFL=EDP.nu*ht/(hx^2);
fprintf('CFL : si %f < 0.5 => convergence\n',CFL);

% 4. Resolution par le schema d'EULER explicite
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     Fonction non fournie : A IMPLEMENTER
disp('Calcul en cours...')
[t,x,u]=EulerExplicite(EDP,Nt,Nx);
disp('Fin du calcul.')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 5. Calcul erreur
Uex=CalculF(EDP.uex,t,x); % Solution exacte
Err=abs(u-Uex);
Ninf=NormInf(Err);
fprintf('Erreur relative  (max en temps et espace) : %.5e\n',max(Ninf)/max(max(abs(Uex))));


% 6. Representations graphiques
MIN=min(min(Uex));
MAX=max(max(Uex));
if PLOT
    figure(1)
    PlotSol(t,x,u,FREQ,'Sol. Appr.',[x(1) x(end) MIN MAX],0.1)
end

MAX=max(max(Err));
if MAX >1
    AXIS=[];
else 
    AXIS=[x(1) x(end) 0 MAX];
end
if PLOT
    figure(2)
    PlotSol(t,x,Err,FREQ,'Erreur',AXIS,0.1)
end

if PLOT
  figure(3)
  plot(t,Ninf);
  xlabel('t')
  title('Erreur en norme L^\infty en espace')
end




